Include "serializer.bb"

Const TAnimalTypeNr = 1
Type TAnimal
	Field x#
	Field y#
	Field hp%
	Field image% ;Handles duerfen nicht serialisiert/deserialisiert werden!
	Field species$
	Field name$
End Type
;Format: ffixss (alles ausser image% wird gespeichert)

Const THouseTypeNr = 2
Type THouse
	Field address$
	Field number%
	Field height#
End Type
;Format: sif (alles wird gespeichert)

Local dog1.TAnimal = New TAnimal
dog1\x# = 75.3
dog1\y# = 400.2
dog1\hp = 10
dog1\species$ = "Dog"
dog1\name$ = "Max"
dog1\image = CreateImage(20,20)

Local dog2.TAnimal = New TAnimal
dog2\x# = 12.3
dog2\y# = 46.7
dog2\hp = 80
dog2\species$ = "Dog"
dog2\name$ = "Hasso"
dog2\image = CreateImage(20,20)

Local cat.TAnimal = New TAnimal
cat\x# = 78.5
cat\y# = 88.5
cat\hp = 5
cat\species$ = "Cat"
cat\name$ = "Kitty"
cat\image = CreateImage(20,20)

Local house1.THouse = New THouse
house1\address = "Waldstrasse"
house1\number = 82
house1\height = 12.5

Local house2.THouse = New THouse
house2\address = "Dorfgasse"
house2\number = 70
house2\height = 8.9

Print("Initial state:")
printObjects()
Print("")
Print("Saving...")
saveObjects("animals.sav")
Print("Deleting...")
deleteObjects()
Print("")
Print("Current state (everything deleted):")
printObjects()
Print("")
Print("Loading...")
loadObjects("animals.sav")
Print("")
Print("Current state (everything reloaded):")
printObjects()
Input("Press Enter to close...")
End

Function saveObjects(path$)
	stream% = WriteFile(path$)
	For a.TAnimal = Each TAnimal
		WriteByte(stream%, TAnimalTypeNr)
		serialize(pointers_getPointer(a), "ffixss", stream%)
	Next
	For h.THouse = Each THouse
		WriteByte(stream%, THouseTypeNr)
		serialize(pointers_getPointer(h), "sif", stream%)
	Next
	CloseFile(stream%)
End Function

Function deleteObjects()
	For a.TAnimal = Each TAnimal
		If (a\image<>0) Then FreeImage a\image
		Delete a
	Next
	For h.THouse = Each THouse
		Delete h
	Next
End Function

Function loadObjects(path$)
	stream% = ReadFile(path$)
	While (Not Eof(stream%))
		typeNr = ReadByte(stream%)
		If (typeNr=TAnimalTypeNr) Then
			Local a.TAnimal = New TAnimal
			deserialize(pointers_getPointer(a), "ffixss", stream%)
		ElseIf (typeNr=THouseTypeNr) Then
			Local h.THouse = New THouse
			deserialize(pointers_getPointer(h), "sif", stream%)
		EndIf
	Wend
	CloseFile(stream)
End Function

Function printObjects()
	Print("")
	Print("##### Animals:")
	For a.TAnimal = Each TAnimal
		Print("### "+a\species$+" "+a\name$+" ###")
		Print("Pos: "+a\x#+"/"+a\y#)
		Print("HP : "+a\hp)
		Print("Image handle: "+a\image)
	Next
	Print("##### Houses:")
	For h.THouse = Each THouse
		Print("### "+h\address$+" "+h\number%+" ###")
		Print("Height: "+h\height#)
	Next
End Function