;Author: David Krywult

Include "pointers.bb"


;format:
;		b = byte
;		h = short
;		i = int
;		f = float
;		s = String
;		x = Ignore four bytes
Function serialize(ptr%, format$, stream%)
	For i=0 To Len(format)-1
		token$ = Mid(format,i+1,1)
		If (token$="b") Then ;Byte
			v = pointers_getInt(ptr + i*4) And 255
			WriteByte(stream%,v)
		ElseIf (token$="h") Then ;Short
			v = pointers_getInt(ptr + i*4) And 65535
			WriteShort(stream%,v)
		ElseIf (token$="i") Then ;Int
			v = pointers_getInt(ptr + i*4)
			WriteInt(stream%,v)
		ElseIf (token$="f") Then ;Float
			vf# = pointers_getFloat(ptr + i*4)
			WriteFloat(stream%,vf#)
		ElseIf (token$="s") Then ;String
			vs$ = pointers_getString(ptr + i*4)
			WriteString(stream%,vs$)
		ElseIf (token$="x") Then ;Ignore
		Else
			DebugLog("Unexpected token while serializing: "+token$)
		EndIf
	Next
End Function

;format:
;		b = byte
;		h = short
;		i = int
;		f = float
;		s = String
;		x = Do not fill field
Function deserialize(ptr%, format$, stream%)
	For i=0 To Len(format)-1
		token$ = Mid(format,i+1,1)
		If (token$="b") Then ;Byte
			v = ReadByte(stream%)
			pointers_setInt(ptr + i*4, v)
		ElseIf (token$="h") Then ;Short
			v = ReadShort(stream%)
			pointers_setInt(ptr + i*4, v)
		ElseIf (token$="i") Then ;Int
			v = ReadInt(stream%)
			pointers_setInt(ptr + i*4, v)
		ElseIf (token$="f") Then ;Float
			vf# = ReadFloat(stream%)
			pointers_setFloat(ptr + i*4, vf#)
		ElseIf (token$="s") Then ;String
			vs$ = ReadString(stream%)
			pointers_setString(ptr + i*4, vs$)
		ElseIf (token$="x") Then ;Do not fill field
		Else
			DebugLog("Unexpected token while deserializing: "+token$)
		EndIf
	Next
End Function
